<?php 
/**
 * builds an advert modul to create model data 
 * @author sven kronshage
 *
 */
class DataSheet {
	
	private $db_prefix = 'datasheet_';
	/**
	 * contains a html string for frontend output
	 * @var string html
	 */
	private $html;
	/**
	 * contains a html string for frontend output
	 * @var string html
	 */
	private $htmlTail;
	
	private $script;
	
	/**
	 * @var array language data
	 */
	private $lang;
	
	/**
	 * @var string address to googleMap
	 */
	private $googleMap = 'http://maps.google.de/maps?f=q&source=s_q&hl=de&geocode=&q=';
	
	public function __construct(){
		if( $_GET['deleteOverFlow'] )
			$this->deleteOverFlow();
		if( $_GET['updateList'] )
			$this->saveList();
		
		if( $_GET['activate'] )
			$this->activate();
		if( !is_admin() ){
			add_action( 'the_posts', array( &$this, 'the_posts' ) );
			add_action('wp_head', array( &$this, 'addToHtmlHead' ) );
			wp_enqueue_script('jquery');
		}
		$this->inc();
		$this->metaBoxes();
		
	}
	private function deleteOverFlow(){
		global $wpdb;
		$sql = "SELECT * FROM  `wp_posts` 
			INNER JOIN `wp_datasheet_field_values` ON `wp_posts`.`ID` = `wp_datasheet_field_values`.`post_id`
			WHERE `post_status` LIKE 'inherit' AND `post_type` LIKE  'revision'
			GROUP BY `wp_posts`.`ID`";
		
		$results = $wpdb->get_results( $sql );
		foreach( $results as $result ){
			$wpdb->query( "DELETE FROM `wp_datasheet_field_values` WHERE `wp_datasheet_field_values`.`post_id` =". $result->ID );
		}
		echo "<br />deletedOverFlow<br />";
	}
	/**
	 * a method to include files
	 */
	private function inc(){
		define( 'DS_PLUGIN_CLASS_PATH', DS_PLUGIN_PATH.'class/' );
		include DS_PLUGIN_PATH.'lang/'.WPLANG.'.php';
		$this->lang = $lang;
		include DS_PLUGIN_CLASS_PATH.'dataSheet-Menu.class.php';
		include DS_PLUGIN_CLASS_PATH.'dataSheet-Desk.class.php';
		include DS_PLUGIN_CLASS_PATH.'dataSheet-Group.class.php';
		include DS_PLUGIN_CLASS_PATH.'dataSheet-Field.class.php';
		include DS_PLUGIN_CLASS_PATH.'dataSheet-Output.class.php';
		
		new Menu();
		
	}
	/**
	 * a mehtod to append data in frontend between html head
	 */
	public function addToHtmlHead(){
		echo '<link rel="stylesheet" href="'.DS_PLUGIN_URL.'css/blitzer/jquery-ui-1.8.4.custom.css" type="text/css" media="screen" />';
		echo '<script type="text/javascript" src="'.DS_PLUGIN_URL.'js/jquery-ui-1.8.4.custom.min.js"></script>';
	}
	
	/**
	 * extended the post data for frontend with dataSheet data
	 * @param object $post
	 */
	public function the_posts( $post ){
		if( $post[0]->ID ){
			$post[0]->dataSheet = array();
			
			global $wpdb;
			
			$table = array();
			$table['value'] 	= $wpdb->prefix.$this->db_prefix.'field_values';
			$table['fields'] 	= $wpdb->prefix.$this->db_prefix.'fields';
			$table['groups'] 	= $wpdb->prefix.$this->db_prefix.'groups';
			
			$groups = $wpdb->get_results( 
				"SELECT `id`, `title`, `frontend_title`, `sort` AS `group_sort` FROM  `".$table['groups']."` 
				 WHERE `visible_frontend` = 1 AND `page` LIKE '".$post[0]->post_type."'  ORDER BY `group_sort`" 
			);
			
			$htmlTemplate = $wpdb->get_results( "SELECT * FROM  `".$wpdb->prefix.$this->db_prefix."output`" );
			$i=0;
			if( sizeof( $groups ) ){
				
				$sizeGroups = sizeof( $groups );
				foreach( $groups as $group ){
					
					$post[0]->dataSheet[$i] = $group;
					$fields = $wpdb->get_results( 
						"SELECT `".$table['fields']."`.`id`, `label`, `unit`, `value_text`, `type_id`, `value_numeric`, `group_id` 
						 FROM  `".$table['fields']."` 
						 INNER JOIN `".$table['value']."` ON `".$table['fields']."`.`id` = `".$table['value']."`.`field_id`   
						 WHERE `group_id` = ".$group->id." AND `post_id` = ".$post[0]->ID."  
						 ORDER BY `sort`" 
					);
					$bool = false;
					
					
					foreach( $fields as $key => $field ){
						if(  $field->value_text || $fields->value_numeric ){
							if( $field->value_text != "-"  )
								$bool = true;
						}
						if( unserialize( $field->value_text ) ){
							$field->value_text = unserialize( $field->value_text );
							if( $field->value_text['link'] ){
								if( $field->value_text['link']['address'] !== 'http://' ){
									$address = $field->value_text['link']['address'];
									$field->value_text = '<a id="opener_'.$field->id.'" href="'.$field->value_text['link']['address'].'" title="'.$field->value_text['link']['label'].'" target="'.$field->value_text['link']['target'].'" >'.$field->value_text['link']['label'].'</a>';
											
									$data['id'] 	= $field->id;
									$data['width'] 	= '1000';
									$data['height'] = '600';
									$data['title']	= $this->lang['uni']['address'].': '.$address;
									$data['url']	= $address;
								
									$field->value_script = $this->buildDialog( $data );
									unset( $data, $address );
								}else {
									$field->value_text = ' ';
								}
							}
							elseif( $field->value_text['email'] ){
								$field->value_text = '<a href="mailto:'.$field->value_text['email']['address'].'" title="'.$field->value_text['email']['label'].'">'.$field->value_text['email']['label'].'</a>';
							}
							elseif( $field->value_text['day'] ){
								if( $field->value_text['day'][0] && $field->value_text['day'][1] )
									$field->value_text = $field->value_text['day'][0].':'.( $field->value_text['day_minute'][0] ? 
										$field->value_text['day_minute'][0] 
									: '00' )
									.' '.$this->lang['uni']['to'].': '.$field->value_text['day'][1].':'.( $field->value_text['day_minute'][1] ?
										$field->value_text['day_minute'][1]
									:
										'00'
									);
								else
									$field->value_text = '';
							}
						}
						
						if( $field->type_id == 7 && $field->value_text ){ //map
							$tmp = $field->value_text;
							$tmp2 = explode('+',  $tmp );
							$field->value_text = '<a id="opener_'.$field->id.'" href="'.$this->googleMap.$field->value_text.'"	title="'.$this->lang['uni']['google_maps'].' '.$field->value_text.'" target="_blank">'.$this->lang['uni']['city_map'].'</a>';
							
							$data['id'] 	= $field->id;
							$data['width'] 	= '680';
							$data['height'] = '500';
							$data['title']	= $this->lang['uni']['route'] .' '.$post[0]->post_title.' nach '.$tmp2[0].' '.$tmp2[1].' '.$tmp2[2];
							$data['url']	= 'http://maps.google.de/maps?f=q&amp;source=s_q&amp;hl=de&amp;geocode=&amp;q='.$tmp.'&amp;z=14&amp;iwloc=A&amp;output=embed';
							
							$field->value_script = $this->buildDialog( $data );
							
							unset( $tmp, $tmp2, $data );
							
						}
						
					}
					if( !sizeof( $fields ) || ! $bool)
						$sizeGroups = $sizeGroups -1;
					if( sizeof( $fields ) && $bool ){
						$post[0]->dataSheet[$i]->fields = $fields;
						$this->AddGroupToPost( $htmlTemplate, $i, $sizeGroups, $group, $fields );
						$i++;
					}
				}
			}
		}
		if( $this->html ){
			$post[0]->post_content = $post[0]->post_content.$this->html;
		}
		
		return $post;
	}
	/**
	 * parse the html template for frontend output
	 * @param sting $htmlTemplate
	 * @param integer $groupCounter
	 * @param integer $sizeGroups
	 * @param object $group
	 * @param object $fields
	 */
	private function AddGroupToPost( &$htmlTemplate, $groupCounter, $sizeGroups, &$group, &$fields ){
		global $wpdb;
		
		if( $groupCounter == 0 ){//first group
			
			$content = explode( "%LOOP_GROUPS%", $htmlTemplate[0]->html );
			$this->html = $content[0];
			$content = explode( "%/LOOP_GROUPS%", $content[1] );
			$htmlTemplate[0]->html = $content[0];
			$this->htmlTail			= $content[1];
			$html =  str_replace( "%FIELD_LABEL%", $field->label , $htmlTemplate[0]->html ); 
			
		}
		// some groups between first and last
			$tmp = explode( "%LOOP_FIELDS%", $htmlTemplate[0]->html );
			$tmpX = $tmp[0];
			
			$tmp = explode( "%/LOOP_FIELDS%", $tmp[1] );
			$tmpY = $tmp[1];
			
			
			$from 		= array( "%FIELD_LABEL%", "%FIELD_VALUE%", "%FIELD_UNIT%" );
			foreach( $fields as $field ){
				if( is_array( $field->value_text ) ){//checkbox
					$size = sizeof( $field->value_text );
					for( $i=0; $i<$size; $i++ ){
						$fieldTmp .= $field->value_text[$i].( $i != ( $size -1 ) ? '<br />' : '' ); 
					}
					$field->value_text = $fieldTmp;
				}
				$to 			= array( $field->label, ( $field->value_text  ? 
						$field->value_text 
					: 
						( $field->value_numeric ? $field->value_numeric : '' ) ), $field->unit );
				if( ! $field->value_text && ! $field->value_numeric )
					continue;
				$fieldHtml		.= str_replace( $from, $to, $tmp[0] );
				$this->script	.= $field->value_script;
				
			}
			
			$this->html .= $tmpX.$fieldHtml.$tmpY;
			unset( $tmpX, $fieldHtml, $tmpY, $tmp, $content, $html );
			$this->html		= str_replace( "%GROUP_LABEL%", ( $group->frontend_title ? $group->frontend_title : $group->title ), $this->html );
			$modulo			= substr( $this->html,  stripos( $this->html, "MODULO" )+7, 1 );
			
			
			$tmp		= explode( "%MODULO_".$modulo."%", $this->html );
			$tmp2		= explode( "%/MODULO_".$modulo."%", $tmp[1] );
			$clearer 	= $tmp2[0];
			
			unset( $tmp, $tmp2 );
			$tmp 		= explode( "%MODULO_".$modulo."%", $this->html );
			$tmp2		= explode( "%/MODULO_".$modulo."%", $this->html );
			
			$this->html =  $tmp[0];
			if( is_numeric( $modulo ) )
				if( $groupCounter % $modulo  )
					$this->html .= $clearer;
			$this->html .= $tmp2[1];
			
		if( $groupCounter  == ( $sizeGroups -1 ) ){// last group
			$this->html .= $this->htmlTail.$this->script; 
		}
		
	}
	/**
	 * build a jquery dialog
	 * @param Array $data
	 */
	private function buildDialog( $data ){
		$script .= '<script type="text/javascript">';
		$script .=  	'jQuery(document).ready(function(){';
		$script .= 		'jQuery("#dialog_'.$data['id'].'").dialog({';
		$script .=			'autoOpen: false,';
		$script .=			'modal: true,';
		$script .=			'minWidth: '.$data['width'].',';
		$script .=			'minHeight: '.$data['height'].',';
		$script .=			'resize: function(event, ui){';
		$script .=				'jQuery("#frame_'.$data['id'].'").attr("width", ( jQuery(this).width() -40 ) );';
		$script .=				'jQuery("#frame_'.$data['id'].'").attr("height", ( jQuery(this).height() -20 ) );';
		$script .=			'}';
		$script .= 		'});';
		$script .=		'jQuery("#opener_'.$data['id'].'").click(function() {';
		$script .=			'jQuery("#frame_'.$data['id'].'").attr("src" , jQuery("#frame_'.$data['id'].'").attr("alt") );';
		$script .=			'jQuery("#dialog_'.$data['id'].'").dialog("open");';
		$script .=			'return false;';
		$script .=		'});';
		$script .= 	'})';
		$script .= '</script>';
		$script .= '<div id="dialog_'.$data['id'].'" title="'.$data['title'].'">';
		$script .= '<iframe id="frame_'.$data['id'].'" width="'.($data['width'] - 40).'" height="'.($data['height'] - 20).'" scrolling="yes" frameborder="0" scrolling="no" marginheight="0" marginwidth="0" alt="'.$data['url'].'" src="#"></iframe>';
		$script .= '</div>';
		return $script;
	}
	/**
	 * if the plugin is activated, than the sql dump will be inserted
	 */
	private function activate(){
		global $wpdb;
		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		
		$sql = "CREATE TABLE IF NOT EXISTS `".$wpdb->prefix.$this->db_prefix."fields` (
  			`id` int(11) NOT NULL AUTO_INCREMENT,
  			`label` varchar(150) NOT NULL,
  			`type_id` int(11) NOT NULL,
  			`unit` varchar(50) NOT NULL,
  			`group_id` int(11) NOT NULL,
  			`filled` text NOT NULL,
  			`sort` int(11) DEFAULT NULL,
  			PRIMARY KEY (`id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=51 ;";
		dbDelta( $sql );
		
		$sql ="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix.$this->db_prefix."field_types` (
			  `id` int(11) NOT NULL AUTO_INCREMENT,
			  `input` varchar(50) NOT NULL,
			  PRIMARY KEY (`id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=8 ;";
		dbDelta( $sql );

		$sql =	"CREATE TABLE IF NOT EXISTS `".$wpdb->prefix.$this->db_prefix."field_values` (
			  `id` int(11) NOT NULL AUTO_INCREMENT,
			  `value_text` text NOT NULL,
			  `value_numeric` double DEFAULT NULL,
			  `field_id` int(11) NOT NULL,
			  `post_id` bigint(20) NOT NULL,
			  PRIMARY KEY (`id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=573 ;";
		dbDelta( $sql );
		
		$sql =	"CREATE TABLE IF NOT EXISTS `".$wpdb->prefix.$this->db_prefix."groups` (
			  `id` int(11) NOT NULL AUTO_INCREMENT,
			  `title` varchar(100) NOT NULL,
			  `frontend_title` varchar(150) NOT NULL,
			  `page` varchar(50) NOT NULL,
			  `context` varchar(50) NOT NULL,
			  `priority` varchar(50) NOT NULL,
			  `visible_frontend` int(11) NOT NULL,
			  `author` varchar(100) NOT NULL,
			  `timestamp` int(11) NOT NULL,
			  `sort` int(11) DEFAULT NULL,
			  PRIMARY KEY (`id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=17 ;";
		dbDelta( $sql );
		
		$sql =	"CREATE TABLE IF NOT EXISTS `".$wpdb->prefix.$this->db_prefix."output` (
			  `id` int(11) NOT NULL AUTO_INCREMENT,
			  `html` text NOT NULL,
			  PRIMARY KEY (`id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;";
		dbDelta( $sql );
		$sql =	"INSERT INTO `".$wpdb->prefix.$this->db_prefix."output` (`id`, `html`) VALUES
			(1, '<hr />\r\n%LOOP_GROUPS%\r\n<div style=\"float: left; width: 300px; margin-bottom: 20px;\">\r\n	<strong>%GROUP_LABEL%</strong><br />\r\n	<table>\r\n	%LOOP_FIELDS%\r\n		<tr>\r\n			<td width=\"100px\" valign=\"top\">%FIELD_LABEL%</td>\r\n			<td>%FIELD_VALUE% %FIELD_UNIT%</td>\r\n		</tr>\r\n	%/LOOP_FIELDS%\r\n	</table>\r\n</div>\r\n%MODULO_2%<div style=\"clear:both;\"></div>%/MODULO_2%\r\n%/LOOP_GROUPS%\r\n');";
		$wpdb->query( $sql );
		
		$sql = "INSERT INTO `".$wpdb->prefix.$this->db_prefix."field_types` (`id`, `input`) VALUES
			(1, 'text'),
			(2, 'textarea'),
			(3, 'link'),
			(4, 'email'),
			(5, 'select'),
			(6, 'day'),
			(7, 'map'),
			(8, 'radio'),
			(9, 'checkbox');";
		$wpdb->query( $sql );
	}
	/**
	 * linking method to add and save meta boxes
	 */
	private function metaBoxes(){
		/* Saves the meta box data. */
		add_action( 'save_post',  array( &$this, 'saveMetaBoxes' ) );
		//add_action( 'edit_post',  array( &$this, 'saveMetaBoxes' ) );
		/* Add the meta box data. */
		add_action( 'admin_menu', array( &$this, 'createMetaBoxes' ) );
		
	}
	/**
	 * create meta boxes
	 */
	public function createMetaBoxes() {
		global $wpdb;
		
		$results = $wpdb->get_results( "SELECT * FROM `".$wpdb->prefix.$this->db_prefix."groups`" );
		
		foreach( $results as $result ){
			add_meta_box( 
				'post-dataSheet-'.$result->id, 
				__($result->title), 
				array( &$this, 'renderData' ), 
				$result->page, 
				$result->context, 
				$result->priority,
				$result->id
			);
		}
	}
	/**
	 * this method saves a list in his order after drag an drop
	 */
	public function saveList(){
		global $wpdb;
		$i = 1;
		foreach( $_GET['fields'] as $field ){
			$sql = "UPDATE `".$wpdb->prefix.$this->db_prefix."fields` SET `sort`= '".$i."' WHERE `id` = ".$field;
			$i++;
			$wpdb->query( $sql );
		}
	}
	/**
	 * saves extended content from datasheet
	 * @param integer $postId
	 */
	public function saveMetaBoxes( $postId ){
		
		if(  $postId == $_POST['post_ID'] ){
			
			if ( !wp_verify_nonce( $_POST['dataSheet_nonce'], 'dataSheet' ) ) {
	    		return $postId;
	  		}
			if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ) 
		    	return $postId;
		
		  	// Check permissions
		  	if ( 'page' == $_POST['post_type'] ) {
		    	if ( !current_user_can( 'edit_page', $post_id ) )
		      		return $postId;
		  	} else {
		    	if ( !current_user_can( 'edit_post', $post_id ) )
		      		return $postId;
			}
		
			global $wpdb;
			
			
			$fieldResults = $wpdb->get_results( 
				"SELECT `".$wpdb->prefix.$this->db_prefix."fields`.`id`, `label`,`type_id`, `unit`, `group_id`, `filled`, `sort`, `input` 
				FROM `".$wpdb->prefix.$this->db_prefix."fields` 
				INNER JOIN `".$wpdb->prefix.$this->db_prefix."field_types` ON 
				`".$wpdb->prefix.$this->db_prefix."fields`.`type_id` = 
				`".$wpdb->prefix.$this->db_prefix."field_types`.`id`" 
			);
			
			foreach( $fieldResults  as $fieldResult ){
				
				$row = $wpdb->get_results( "SELECT * FROM `".$wpdb->prefix.$this->db_prefix."field_values` 
					WHERE `post_id` =".$postId." AND `field_id`=".$fieldResult->id 
				);
				
				
				
				if( is_array( $_POST['dataSheet_'.$fieldResult->id]['link'] ) ){
					if( !strstr($_POST['dataSheet_'.$fieldResult->id]['link']['address'], 'http://') ){
						$_POST['dataSheet_'.$fieldResult->id]['link']['address'] = 'http://'.$_POST['dataSheet_'.$fieldResult->id]['link']['address'];
					}
					$_POST['dataSheet_'.$fieldResult->id] = serialize( $_POST['dataSheet_'.$fieldResult->id] );
				}
				elseif( is_array( $_POST['dataSheet_'.$fieldResult->id]['email'] ) ){
					$_POST['dataSheet_'.$fieldResult->id] = serialize( $_POST['dataSheet_'.$fieldResult->id] );
				}
				elseif( is_array( $_POST['dataSheet_'.$fieldResult->id]['day'] ) ){
					$_POST['dataSheet_'.$fieldResult->id] = serialize( $_POST['dataSheet_'.$fieldResult->id] );
				}
				elseif( is_array( $_POST['dataSheet_'.$fieldResult->id] ) ){
					$_POST['dataSheet_'.$fieldResult->id] = serialize( $_POST['dataSheet_'.$fieldResult->id] );
				}
				
				
				if( $row[0] ){
					$sql = "UPDATE `".$wpdb->prefix.$this->db_prefix."field_values` "
						.( is_numeric( $_POST['dataSheet_'.$fieldResult->id] ) ? 
							"SET `value_text` = '', `value_numeric` = '".$_POST['dataSheet_'.$fieldResult->id]."' " 
						: 
							"SET `value_text` = '".$_POST['dataSheet_'.$fieldResult->id]."', `value_numeric` = '' "
						).
						" WHERE `post_id` = ".$postId." AND `field_id` = ".$fieldResult->id."; ";
				}else {
				
					$sql = "INSERT INTO `".$wpdb->prefix.$this->db_prefix."field_values` 
						(`id`, 
						`value_text`, 
						`value_numeric`, 
						`field_id`,
						`post_id`
						) 
						VALUES (NULL,
						'".(!is_numeric ( $_POST['dataSheet_'.$fieldResult->id] ) ?  $_POST['dataSheet_'.$fieldResult->id] : '')."', 
						'".(is_numeric ( $_POST['dataSheet_'.$fieldResult->id] ) ?  $_POST['dataSheet_'.$fieldResult->id] : 'NULL')."',
						'".$fieldResult->id."', 
						'".$postId."'); ";
					
				}
				$wpdb->query( $sql );
			}
		}
	}
	
	/**
	 * create a model data input
	 */
	public function renderData( $post, $groupId ){
		global $wpdb;
		$results = $wpdb->get_results( 
			"SELECT `".$wpdb->prefix.$this->db_prefix."fields`.`id`, `label`,`type_id`, `unit`, `group_id`, `filled`, `sort`, `input` 
			FROM `".$wpdb->prefix.$this->db_prefix."fields` 
			INNER JOIN `".$wpdb->prefix.$this->db_prefix."field_types` ON 
			`".$wpdb->prefix.$this->db_prefix."fields`.`type_id` = 
			`".$wpdb->prefix.$this->db_prefix."field_types`.`id` WHERE `group_id`=".$groupId['args']." ORDER BY `sort`"
			
		);
		
		if( $_GET['post'] ){
			foreach( $results as $key => $result ){
				$tmp = $wpdb->get_results( "SELECT * FROM  `".$wpdb->prefix.$this->db_prefix."field_values` 
					WHERE `field_id` =  ".$result->id." AND `post_id` = ".$_GET['post'] );
				if( $tmp[0] ){
					$results[$key]->value_text 		= $tmp[0]->value_text;
					$results[$key]->value_numeric 	= $tmp[0]->value_numeric;
				}
			}
		}
		$results = $this->renderInput( $results );
		$url = 'http://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'];
		include DS_PLUGIN_PATH_TPL.'renderDataBox.php';
		
	}
	
	/**
	 * render input fields
	 * @param db-object $rows
	 */
	private function renderInput( $rows ){
		foreach( $rows as $key => $row ){
			$label = '<label for="dataSheet_'.$row->id.'">'.($row->label ? $row->label.':' : '').'</label>';
			switch( $row->input ){
				case 'text': // <input type="text" />
					$input = '<input size="50" type="text" id="dataSheet_'.$row->id.'" 
						name="dataSheet_'.$row->id.'" value="'.
						( $row->value_text ? 
							$row->value_text 
						: 
							( $row->value_numeric ? $row->value_numeric : '' ) 
						)
						.'" />&nbsp;'.
						( $row->unit ? $row->unit : '');
				break;
				case 'textarea': // <textarea />
					$input = '<textarea cols="40" name="dataSheet_'.$row->id.'" id="dataSheet_'.$row->id.'">'.
						( $row->value_text ? 
							$row->value_text 
						: 
							( $row->value_numeric ? $row->value_numeric : '' ) 
						)
						.'</textarea>';
				break;
				case 'link':// <input type="text" />
					if( unserialize( $row->value_text ) )
						$value = unserialize( $row->value_text );
					else {
						$value['link']['label'] = $row->value_text;
						$value['link']['address'] = $row->value_text;
						
					}
					
					$input = '<div style="float: left;">';
					$input .= '<label for="dataSheet_desc_'.$row->id.'">'.$this->lang['uni']['label'].':</label><br />';
					$input .= '<input size="50" type="text" id="dataSheet_desc_'.$row->id.'" 
						name="dataSheet_'.$row->id.'[link][label]" value="'.
						( $value['link']['label'] ? 
							$value['link']['label'] 
						: 
							( $row->value_numeric ? $row->value_numeric : '' ) 
						)
						.'" />&nbsp;<br /><br />'.
						( $row->unit ? $row->unit : '');
					$input .= '<label for="dataSheet_target'.$row->id.'">'.$this->lang['uni']['target'].':</label><br />';
					$input .= '<select name="dataSheet_'.$row->id.'[link][target]" id="dataSheet_target'.$row->id.'">';
					$input .= 	'<option value="_blank" '.($value['link']['target'] == '_blank' ? 
						'selected="selected"' : "").' >'.$this->lang['uni']['_blank'].'</option>';
						
					$input .= 	'<option value="_self" '.($value['link']['target'] == '_self' ? 
						'selected="selected"' : "").' >'.$this->lang['uni']['_self'].'</option>';
					$input .= '</select><br /><br />';
					$input .= '<label for="dataSheet_address'.$row->id.'">'.$this->lang['uni']['address'].':</label><br />';
					$input .= '<input size="50" type="text" id="dataSheet_address'.$row->id.'" 
						name="dataSheet_'.$row->id.'[link][address]" value="'.
						( $value['link']['address'] ? 
							$value['link']['address'] 
						: 
							( $row->value_numeric ? $row->value_numeric : '' ) 
						)
						.'" />&nbsp;<br />'.
						( $row->unit ? $row->unit : '');
					$input .= '</div><div style="clear: both;"></div><br />';
					
				break;
				case 'email':// <input type="text" />
					if( unserialize( $row->value_text ) )
						$value = unserialize( $row->value_text );
					else {
						$value['email']['label'] = $row->value_text;
						$value['email']['address'] = $row->value_text;
						
					}
					
					$input = '<div style="float: left;">';
					$input .= '<label for="dataSheet_desc_'.$row->id.'">'.$this->lang['uni']['label'].':</label><br />';
					$input .= '<input size="50" type="text" id="dataSheet_desc_'.$row->id.'" 
						name="dataSheet_'.$row->id.'[email][label]" value="'.
						( $value['email']['label'] ? 
							$value['email']['label'] 
						: 
							( $row->value_numeric ? $row->value_numeric : '' ) 
						)
						.'" />&nbsp;<br /><br />'.
						( $row->unit ? $row->unit : '');
					$input .= '<label for="dataSheet_address'.$row->id.'">'.$this->lang['uni']['address'].':</label><br />';
					$input .= '<input size="50" type="text" id="dataSheet_address'.$row->id.'" 
						name="dataSheet_'.$row->id.'[email][address]" value="'.
						( $value['email']['address'] ? 
							$value['email']['address'] 
						: 
							( $row->value_numeric ? $row->value_numeric : '' ) 
						)
						.'" />&nbsp;<br />'.
						( $row->unit ? $row->unit : '');
					$input .= '</div><div style="clear: both;"></div><br />';
					
				break;
				case 'select':// <select />
					$row->filled = unserialize( $row->filled );
					$input = '<select name="dataSheet_'.$row->id.'" id="dataSheet_'.$row->id.'">';
					$size= sizeof( $row->filled );
					for( $i=0; $i<$size; $i++ ){
						$input .= '<option value="'.$row->filled[$i].'" '.($row->value_text == $row->filled[$i] ? 'selected="selected"' : '' ).' >'.
							$row->filled[$i].'</option>';
					}
					$input .= '</select>';
					
				break;
				case 'radio':// <input type="radio" />
					$row->filled = unserialize( $row->filled );
					$size= sizeof( $row->filled );
					$input = '<div style="float: left;">';
					for( $i=0; $i<$size; $i++ ){
						$input .= '<input type="radio" name="dataSheet_'.$row->id.'" value="'.$row->filled[$i].'" id="dataSheet_'.$row->id.'_'.$i.'" '.
							($row->value_text == $row->filled[$i] ? 
								'checked="checked"' 
							: 
								'' 
							).' /> '.
						'<label for="dataSheet_'.$row->id.'_'.$i.'">'.$row->filled[$i].'</label><br />';
					}
					$input .= '</div><div style="clear: both;"></div><br />';
					
				break;
				case 'checkbox':// <input type="checkbox" />
					$row->filled = unserialize( $row->filled );
					$row->value_text = unserialize( $row->value_text );
					$sizeFilled= sizeof( $row->filled );
					$sizeValues= sizeof( $row->value_text );
					$input = '<div style="float: left;">';
					for( $i=0; $i<$sizeFilled; $i++ ){
						$input .= '<input type="checkbox" name="dataSheet_'.$row->id.'[]" value="'.$row->filled[$i].'" id="dataSheet_'.$row->id.'_'.$i.'" ';
						for( $j=0; $j< $sizeValues; $j++ ){
							if( $row->value_text[$j] == $row->filled[$i] )
								$input .= 'checked="checked" ';	
						}
						$input .= ' />';
						$input .= '<label for="dataSheet_'.$row->id.'_'.$i.'">'.$row->filled[$i].'</label><br />';
					}
					$input .= '</div><div style="clear: both;"></div><br />';
					
				break;
				case 'day':// <input type="text" />
					unset( $input );
					if( unserialize( $row->value_text ) ){
						$value = unserialize( $row->value_text );
					}
					for( $h=0; $h<2; $h++ ){
						if( $h == 1 )
							$input .='&nbsp;<label for="dataSheet_'.$row->id.'_'.$h.'">'.$this->lang['uni']['to'].':</label>&nbsp;';
						$input .= '<select name="dataSheet_'.$row->id.'[day]['.$h.']" id="dataSheet_'.$row->id.( $h ? '_'.$h : '' ).'">';
						$input .= '<option value="">--</option>';
						for( $i=0; $i<=23; $i++ ){
							$j= ( $i<10 ? '0'.$i : $i );
							$input .= '<option value="'.$j.'" '.( $value['day'][$h] == $j ? 
								'selected="selected"' 
							: 
								'' 
							).'  >'.$j.'</option>';
						}
						$input .= '</select>';
						$input .= '<select name="dataSheet_'.$row->id.'[day_minute]['.$h.']" id="dataSheet_'.$row->id.( $h ? '_'.$h : '' ).'">';
						$input .= '<option value="">--</option>';
						for( $i=0; $i<=55; $i=$i+5 ){
							$j= ( $i<10 ? '0'.$i : $i );
							$input .= '<option value="'.$j.'" '.( $value['day_minute'][$h] == $j ? 
								'selected="selected"' 
							: 
								'' 
							).'  >'.$j.'</option>';
						}
						$input .= '</select>';
					}
					$input .= '&nbsp;'.$row->unit;
				break;
				case 'map':// <input type="text" />
					if( $row->value_text )
						$tmp = explode( "+", $row->value_text );
					$input = '<div style="float: left;" id="dataSheetMap_'.$row->id.'">';
					$input .= '<label for="dataSheetMapCity_'.$row->id.'">'.$this->lang['uni']['city'].': </label><br />';
					$input .= '<input type="text" size="50" id="dataSheetMapCity_'.$row->id.'" value="'.$tmp[0].'" /><br /><br />';
					$input .= '<label for="dataSheetMapStreet_'.$row->id.'">'.$this->lang['uni']['street'].': </label><br />';
					$input .= '<input type="text" size="50" id="dataSheetMapStreet_'.$row->id.'" value="'.$tmp[1].'" /><br /><br />';
					$input .= '<label for="dataSheetMapHouseId_'.$row->id.'">'.$this->lang['uni']['house_id'].': </label><br />';
					$input .= '<input type="text" size="10" id="dataSheetMapHouseId_'.$row->id.'" value="'.$tmp[2].'" />';
					$input .= '<input type="hidden" name="dataSheet_'.$row->id.'" id="dataSheet_'.$row->id.'" value="'.$row->value_text.'" />';
					
					
					$input .= '<script type="text/javascript">';
					$input .= 'var city;';
					$input .= 'var street;';
					$input .= 'var houseId;';
					$input .= 	'jQuery(document).ready(function(){'."\n";
					
					$input .= 		'jQuery("#dataSheetMapCity_'.$row->id.'").change(function(){'."\n";
					$input .=			'city 		= jQuery(this).val();'."\n";
					$input .=			'street 	= jQuery("#dataSheetMapStreet_'.$row->id.'").val();'."\n";
					$input .=			'houseId 	= jQuery("#dataSheetMapHouseId_'.$row->id.'").val();'."\n";
					$input .= 		'})'."\n";

					$input .= 		'jQuery("#dataSheetMapStreet_'.$row->id.'").change(function(){'."\n";
					$input .=			'city	 	= jQuery("#dataSheetMapCity_'.$row->id.'").val();'."\n";
					$input .=			'street 	= jQuery(this).val();'."\n";
					$input .=			'houseId 	= jQuery("#dataSheetMapHouseId_'.$row->id.'").val();'."\n";
					$input .=			'if( street && city ){'."\n";
					$input .= 				'jQuery("#mapLink_'.$row->id.'").attr("href", "'.$this->googleMap.'" + city + "+" + street);'."\n";
					$input .= 				'jQuery("#dataSheet_'.$row->id.'").val( city + "+" + street);'."\n";
					$input .= 			'}'."\n";
					$input .= 			'else{'."\n";
					$input .= 				'jQuery("#mapLink_'.$row->id.'").attr("href", "'.$this->googleMap.'");'."\n";
					$input .= 				'jQuery("#dataSheet_'.$row->id.'").val( "" );'."\n";
					$input .= 			'}'."\n";
					$input .= 		'})'."\n";

					$input .= 		'jQuery("#dataSheetMapHouseId_'.$row->id.'").keyup(function(){'."\n";
					$input .=			'city	 	= jQuery("#dataSheetMapCity_'.$row->id.'").val();'."\n";
					$input .=			'street 	= jQuery("#dataSheetMapStreet_'.$row->id.'").val();'."\n";
					$input .=			'houseId 	= jQuery(this).val();'."\n";
					$input .=			'if( street && city && houseId ){'."\n";
					$input .= 				'jQuery("#mapLink_'.$row->id.'").attr("href", "'.$this->googleMap.'" + city + "+" + street + "+" + houseId);'."\n";
					$input .= 				'jQuery("#dataSheet_'.$row->id.'").val( city + "+" + street + "+" + houseId)'."\n";
					$input .= 			'}'."\n";
					$input .= 			'else{'."\n";
					$input .= 				'jQuery("#mapLink_'.$row->id.'").attr("href", "'.$this->googleMap.'");'."\n";
					$input .= 				'jQuery("#dataSheet_'.$row->id.'").val( "" );'."\n";
					$input .= 			'}'."\n";
					$input .= 		'})'."\n";

					$input .= 	'})';
					$input .= '</script>';
					
					$input .= '<br /><a id="mapLink_'.$row->id.'" href="http://maps.google.de/maps?f=q&source=s_q&hl=de&geocode=&q='.$row->value_text.'" target="_blank" >Check-It</a>';
					
					$input .= '</div><div style="clear: both;"></div><br />';
				break;
	
				
			}
			$rows[$key]->input = $input;
			$rows[$key]->labelfor = $label;
		}
		return $rows;
	}
}
 
?>